#ifndef _BASICFRAME_H
#define _BASICFRAME_H

#include "wx.h"


class Frame;                // introduce name; define later
class TextFrame;
class BasicFrame;

class DrawingCanvas: public wxCanvas
{
    BasicFrame *myFrame;

  public:
    DrawingCanvas(BasicFrame *frame, int x, int y, int w, int h, 
                              long style = wxRETAINED);
    ~DrawingCanvas(void) ;
    void OnEvent(wxMouseEvent& event);
    void OnPaint();
};


class BasicFrame : public wxFrame {
  Frame         *frame;  // of which this BasicFrame is a part
  DrawingCanvas *canvas; // drawing area
  friend class Frame;    // allow direct access to canvas;

  void CreateBasicFrame(Frame *fr);

public:

  BasicFrame( char* title, int x, int y, int w, int h, Frame* fr = (Frame*)0);
  BasicFrame( char* title, Frame* fr = (Frame*)0);

  void OnMenuCommand(int id);
  Bool OnClose();

};

class BasicTextFrame : public wxFrame {
  TextFrame     *frame;      // of which this BasicFrame is a part
  wxTextWindow  *textWindow; // drawing area
  friend class TextFrame;    // allow direct access to TextWindow;

  void CreateBasicFrame(TextFrame *fr);

public:

  BasicTextFrame( char* title, int x, int y, int w, int h, 
                               TextFrame* fr = (TextFrame*)0);
  BasicTextFrame( char* title, TextFrame* fr = (TextFrame*)0);

  void OnMenuCommand(int id);
  Bool OnClose();

};

#define BASIC_FRAME_QUIT       100




#endif






