#include "TextFrame.h"
#include "wx.h"


void TextFrame::CreateIfNeeded() {
 if (!frame) {
      frame = new BasicTextFrame( name, xCoord, yCoord, 
                                  width, height, this);
      frame->Show(TRUE);
   }
}

TextFrame::TextFrame(char *nm, int x, int y, int w, int h) {
     name   = copystring(nm); 
     xCoord = x; yCoord = y;
     width = w; height = h;
     frame  = (BasicTextFrame*)0; 
}

TextFrame::TextFrame(char *nm, int x, int y) {
     name   = copystring(nm); 
     xCoord = x; yCoord = y;
     width = 100; height = 100;
     frame  = (BasicTextFrame*)0; 
}
  
  
TextFrame::TextFrame(char *nm) {
     name   = copystring(nm); 
     xCoord = 1; yCoord = 1;
     width = 100; height = 100;
     frame  = (BasicTextFrame*)0; 
}

TextFrame::TextFrame(){
     name = copystring("TextFrame");
     xCoord = 1; yCoord = 1;
     width = 100; height = 100;
     frame  = (BasicTextFrame*)0; 
}
        
TextFrame::~TextFrame() {
//     if (frame) delete frame;
}

void TextFrame::MoveTo( int newx, int newy ) {
       CreateIfNeeded();
       xCoord = newx; yCoord = newy;
       frame->SetSize( xCoord, yCoord, width, height);
}

void TextFrame::Resize( int w, int h) {
       CreateIfNeeded();        
       width = w; height = h;
       frame->SetSize( xCoord, yCoord, width, height);
}

void TextFrame::Resize(float factor) {
       CreateIfNeeded();
       width = width*factor; height = height*factor;
       frame->SetSize( xCoord, yCoord, width, height);
}


int TextFrame::IsNamed(char *nm) {
   if (strcmp(name, nm) == 0) return 1;
   return 0;
 }

TextFrame& TextFrame::operator<<(char *s){
  CreateIfNeeded();
  (*(frame->textWindow)) << s;
  return *this;
}
TextFrame& TextFrame::operator<<(int i){
  CreateIfNeeded();
  (*(frame->textWindow)) << i;
  return *this;
}
TextFrame& TextFrame::operator<<(long l){
  CreateIfNeeded();
  (*(frame->textWindow)) << l;
  return *this;
}
TextFrame& TextFrame::operator<<(float f){
  CreateIfNeeded();
  (*(frame->textWindow)) << f;
  return *this;
}
TextFrame& TextFrame::operator<<(double d){
  CreateIfNeeded();
  (*(frame->textWindow)) << d;
  return *this;
}
TextFrame& TextFrame::operator<<(char c){
  CreateIfNeeded();
  (*(frame->textWindow)) << c;
  return *this;
}








