#include "FrameMgr.h"
#include "Frame.h"
#include "Program.h"

/**
This sample program illustrates the use of the FrameManager
class that was discused in section 3.4
**/

FrameManager manager(5);
Frame* one;
Frame* two;
Frame* three;

void OnStart(){
 one = new Frame("First Frame", Location(100,100), Shape(100,200));
 two = new Frame("Second Frame", Location(300,100), Shape(100,200));
 three = new Frame("Third Frame", Location(500,100), Shape(100,200));

 manager.Add(one);
 manager.Add(two);
 manager.Add(three);
 one->DrawText("Click here", Location(20,20));
 two->DrawText("Click here", Location(20,20));
 three->DrawText("Click here", Location(20,20));
};

void OnPaint() {
};

void OnTimerEvent () {
};

void OnMouseEvent(char* frameName, int x, int y, int buttonState) {
	if (buttonState & leftButtonDown) {
		Frame* whichFrame = manager.FindByName(frameName);
		if (whichFrame) {
			whichFrame->Clear();
			whichFrame->DrawText(frameName, Location(x,y));
		}
	}

};