#include "BlinkMsg.h"
#include "wx.h"

BlinkingMessage::BlinkingMessage(char *textString, Location whereAt){
  text = copystring(textString);
  location = whereAt;
  visible = 0;
}

BlinkingMessage:: BlinkingMessage(Location whereAt){
  text = "";
  location = whereAt;
  visible = 0;
}

void BlinkingMessage::DisplayIn(Frame& whichFrame) {
   frame = &whichFrame;
}

void BlinkingMessage::MoveTo(Location newLocation){
  if (frame && visible) {
     Clear();
     location = newLocation;
     Draw();
   }
  else location = newLocation;
}

void BlinkingMessage::SetText(char *newText){
  if (frame && visible) {
     Clear();
     delete text;
     text = copystring(newText);
     Draw();
   }
  else {
     delete text;
     text = copystring(newText);
   }
}

void BlinkingMessage::Blink() {
     if (visible) {
         Clear();
         visible = 0;
     }
     else {
         Draw();
         visible = 1;
     }
}
 
void BlinkingMessage::Redraw() {
     if (visible)
        Draw();
}

void BlinkingMessage::Draw() {
        frame->DrawText(text, location);
}

void BlinkingMessage::Clear() {
     Shape msgShape = frame->TextSize(text);
     frame->Clear(location, msgShape);
}

char* BlinkingMessage::GetText(){
  return copystring(text);
} 

BlinkingMessage:: ~BlinkingMessage(){
  delete text;
}
