
#include "BscFrame.h"
#include "Frame.h"
#include "Base.h"
#include "Program.h"


DrawingCanvas::DrawingCanvas (BasicFrame *frame, int x, int y, int w, int h, 
                              long style): wxCanvas(frame, x, y, w, h, style)
{
  myFrame = frame;
}

void DrawingCanvas::OnEvent( wxMouseEvent& event) {
  float x, y;
  event.Position(&x, &y);
  int buttonState = 0;
  if (event.LeftDown())   buttonState |= leftButtonDown;
  if (event.RightDown())  buttonState |= rightButtonDown;
  if (event.MiddleDown()) buttonState |= middleButtonDown;
  if (event.Dragging())   buttonState |= isDragging;
  OnMouseEvent(myFrame->GetTitle(), (int)x, (int)y , buttonState);
}

void DrawingCanvas::OnPaint() {
  ::OnPaint();
}

DrawingCanvas::~DrawingCanvas() {}

// BasicFrame class

void BasicFrame::CreateBasicFrame(Frame *fr) {
       frame = fr; 
       wxMenu* fileMenu = new wxMenu;
       fileMenu->Append(BASIC_FRAME_QUIT, "Quit");
       wxMenuBar* menuBar = new wxMenuBar;
       menuBar->Append(fileMenu, "File");
       this->SetMenuBar(menuBar);

       int width, height;
       GetClientSize(&width, &height);
       canvas = new DrawingCanvas(this, 0, 0, width, height, wxRETAINED);
       canvas->SetBackground(wxWHITE_BRUSH);
       canvas->SetCursor    (new wxCursor(wxCURSOR_PENCIL));
       canvas->SetPen       (new wxPen("RED", 1, wxSOLID));
       canvas->SetFont      (new wxFont(18, wxROMAN, wxNORMAL, wxNORMAL));

}
BasicFrame::BasicFrame( char* title, int x, int y, int w, int h, 
                        Frame* fr ) :
       wxFrame(NULL, title, x, y, w, h) 
{
      
       CreateBasicFrame(fr);
}

BasicFrame::BasicFrame( char* title, Frame* fr ) :       
       wxFrame(NULL, title, -1, -1, -1, -1) 
{
       CreateBasicFrame(fr);

}

void BasicFrame::OnMenuCommand(int id) {
       switch(id) {
         case BASIC_FRAME_QUIT:
             //  if (frame) frame->OnQuit();
               delete this;
               break;
	}
}


Bool BasicFrame::OnClose() { return TRUE; }

// BasicTextFrame class

void BasicTextFrame::CreateBasicFrame(TextFrame *fr) {
       frame = fr; 
       wxMenu* fileMenu = new wxMenu;
       fileMenu->Append(BASIC_FRAME_QUIT, "Quit");
       wxMenuBar* menuBar = new wxMenuBar;
       menuBar->Append(fileMenu, "File");
       this->SetMenuBar(menuBar);

       int width, height;
       GetClientSize(&width, &height);
       textWindow = new wxTextWindow(this, 0, 0, width, height );
}

BasicTextFrame::BasicTextFrame( char* title, int x, int y, int w, int h, 
                        TextFrame* fr) :
       wxFrame(NULL, title, x, y, w, h) 
{
      
       CreateBasicFrame(fr);
}

BasicTextFrame::BasicTextFrame( char* title, TextFrame* fr ) :       
       wxFrame(NULL, title, -1, -1, -1, -1) 
{
       CreateBasicFrame(fr);

}

void BasicTextFrame::OnMenuCommand(int id) {
       switch(id) {
         case BASIC_FRAME_QUIT:
             //  if (frame) frame->OnQuit();
               delete this;
               break;
	}
}


Bool BasicTextFrame::OnClose() { return TRUE; }





