#include "Message.h"
#include "wx.h"

Message::Message(char *textString, Location whereAt){
  text = copystring(textString);
  location = whereAt;
}

Message:: Message(Location whereAt){
  text = "";
  location = whereAt;
}

void Message::DisplayIn(Frame& whichFrame) {
   frame = &whichFrame;
 }

void Message::MoveTo(Location newLocation){
  if (frame) {
     Clear();
     location = newLocation;
     frame->DrawText(text, location);
   }
  else location = newLocation;
}

void Message::SetText(char *newText){
  if (frame) {
     Clear();
     delete text;
     text = copystring(newText);
     Draw();
   }
  else {
     delete text;
     text = copystring(newText);
   }
}

void Message::Draw() {
   if(frame) {
     frame->DrawText(text, location);
   }
}

void Message::Clear() {
   if(frame) {
     Shape msgShape = frame->TextSize(text);
     frame->Clear(location, msgShape);
   }
}

char* Message::GetText(){
  return copystring(text);
} 

Message:: ~Message(){
  delete text;
}
