
#include "Base.h"
#include "Frame.h"
#include "Canvas.h"
#include "Button.h"
#include "Panel.h"
#include "TextBox.h"
#include "Program.h"


/* This program illustrates the use of interactive elements - Buttons
    and TextBoxes - and the way to construct an interface using an
    association among objects. Notice that the new classes Canvas and
    Panel.

    Also notice the new function "OnPush" that is called when any
    button is pushed. The argument to the function gives the name of
    the button that was pushed.

    This program allows the user to enter text into a TextBox and,
    when the "Copy" button is pushed, this text is written to a
    Canvas object.
  
*/

  
// Declare object here

     Frame window  ("TestWindow", Location(100,100), Shape(300, 300));
     Canvas canvas (window, "DrawAreas",  Location(1, 1),  
		                                  Shape(300, 100));
     Panel  panel  (window, "Controls", Location(10, 150), 
		                                Shape(250, 100));
     Button button ("Copy", Location(5, 5), Shape(50,30)); 
     TextBox tbox(Location(5,50), Shape(150,30), "Enter:");
     char *textString1;
	 char *textString2;
     
void OnStart()	      // called once when "Start" button pushed
{  canvas.Clear();
   panel.Add(button);
   panel.Add(tbox);
   textString1 = "";
   textString2 = "";
}


void OnPush(char *buttonLabel) 
{  if (button.IsNamed(buttonLabel)) 
   {   canvas.Clear(); 
       textString1 = copystring(tbox.GetText());
       textString2 = copystring(buttonLabel);
	   canvas.DrawText(textString1, Location(20, 20));
	   canvas.DrawText(textString2, Location(20, 50));
	   
   }
}

void OnPaint()
{ canvas.DrawText(textString1, Location(20,20));  
  canvas.DrawText(textString2, Location(20,50));  
}

void OnTimerEvent(char* clockName) 
{
}

void OnMouseEvent(char *canvasName, int x, int y, int keys)
{ if(keys & leftButtonDown) OnPaint();
}








