
#include "Base.h"
#include "Frame.h"
#include "Canvas.h"
#include "Button.h"
#include "Panel.h"
#include "TextBox.h"
#include "Message.h"


/* This program illustrates the use of interactive elements - Buttons
    and TextBoxes - and the way to construct an interface using an
    association among objects. Notice that the new classes Canvas and
    Panel.

    Also notice the new function "OnPush" that is called when any
    button is pushed. The argument to the function gives the name of
    the button that was pushed.

    This program allows the user to enter text into a TextBox and,
    when the "Copy" button is pushed, this text is written to a
    Canvas object.

    This sample program is similar to Sample1.cpp except that it
    includes the use of two Buttons and uses a Message object to
    maintain the text to be displayed.
*/

  
// Declare object here

     Frame   window ("TestWindow", Location(100,100), Shape(500, 300));
     Canvas  canvas (window, "DrawAreas",  Location(1, 1),  Shape(100, 100));
     Panel   panel  (window, "Controls", Location(150, 10), Shape(300, 100));
     Button  copy   ("Copy",  Location(5, 5),  Shape(50,30)); 
     Button  clear  ("Clear", Location(65, 5), Shape(50,30)); 
     TextBox tbox   (Location(5,50), Shape(150,30), "Enter:");
     Message txt   ("", Location(20,20));
     
void OnStart()	      // called once when "Start" button pushed
{  canvas.Clear();
   panel.Add(copy);
   panel.Add(clear);
   panel.Add(tbox);
   txt.DisplayIn(canvas);
}


void OnPush(char *buttonName) 
{  if (copy.IsNamed(buttonName)) 
   {   txt.SetText(tbox.GetText()); 
   }
   if (clear.IsNamed(buttonName))
   {  tbox.SetText("");
      txt.SetText("");
   }
}

void OnPaint()
{ txt.Draw();
}

void OnTimerEvent(char* clockName) 
{
}

void OnMouseEvent(char *canvasName, int x, int y, int keys)
{
}








