#include "BlinkMsg.h"
#include "wx.h"

BlinkingMessage::BlinkingMessage(char *textString, Location whereAt){
  text = copystring(textString);
  location = whereAt;
  visible = 0;
}

BlinkingMessage:: BlinkingMessage(Location whereAt){
  text = "";
  location = whereAt;
  visible = 0;
}

void BlinkingMessage::DisplayIn(Canvas& whichCanvas) {
   canvas = &whichCanvas;
}

void BlinkingMessage::MoveTo(Location newLocation){
  if (canvas && visible) {
     Clear();
     location = newLocation;
     Draw();
   }
  else location = newLocation;
}

void BlinkingMessage::SetText(char *newText){
  if (canvas && visible) {
     Clear();
     delete text;
     text = copystring(newText);
     Draw();
   }
  else {
     delete text;
     text = copystring(newText);
   }
}

void BlinkingMessage::Blink() {
  if(visible) {
     Clear();
     visible = 0;
    }
   else {
      Draw();
      visible = 1;
    }
}
 
void BlinkingMessage::Redraw() {
     if (visible)
        Draw();
}

void BlinkingMessage::Draw() {
    if(canvas) 
       canvas->DrawText(text, location);
}

void BlinkingMessage::Clear() {
   if (canvas) {
	 Shape msgShape = canvas->TextSize(text);
     canvas->Clear(location, msgShape);
   }
}

char* BlinkingMessage::GetText(){
  return copystring(text);
} 

BlinkingMessage:: ~BlinkingMessage(){
  delete text;
}
