
#include "Frame.h"
#include "BscFrame.h"
#include "wx.h"

void Frame::CreateIfNeeded() {
 if (!frame) {
      frame = new BasicFrame( name, location.Xcoord(), location.Ycoord(),
                                    shape.Width(), shape.Height(), this );
      frame->Show(TRUE); 
      frame->SetSize( location.Xcoord(), location.Ycoord(),
                      shape.Width()+1, shape.Height()+1);
   }
}

Frame::Frame(char *nm, Location loc, Shape sh) {
     name     = copystring(nm); 
     location = loc;
     shape    = sh;
     frame    = (BasicFrame*)0; 
}

Frame::Frame(char *nm, Location loc) {
     name     = copystring(nm); 
     location = loc;
     shape    = Shape(100,100);
     frame    = (BasicFrame*)0; 
}
  
Frame::Frame(char *nm) {
     name   = copystring(nm); 
     location = Location(100,100);
     shape    = Shape(100,100);
     frame  = (BasicFrame*)0; 
}

Frame::Frame() {
     name = "NoName";
     location = Location(100,100);
     shape    = Shape(100,100);
     frame  = (BasicFrame*)0; 
}   


Frame::~Frame() {}


void Frame::MoveTo(Location loc ) {
       CreateIfNeeded();
       location = loc;
       frame->SetSize( loc.Xcoord(),  loc.Ycoord(),
                       shape.Width(), shape.Height());
}

void Frame::Resize(Shape sh) {
       CreateIfNeeded();        
       shape = sh;
       frame->SetSize( location.Xcoord(), location.Ycoord(),
                       sh.Width(), sh.Height());
}

void Frame::Resize(float factor) {
       CreateIfNeeded();
       shape = Shape((int)(shape.Width()*factor), 
                    (int)(shape.Height()*factor));
       frame->SetSize( location.Xcoord(), location.Ycoord(),
                       shape.Width(), shape.Height());
}



int Frame::IsNamed(char *nm) {
   if (strcmp(name, nm) == 0) return 1;
   return 0;
 }





