#include "Message.h"
#include "wx.h"

Message::Message(char *textString, Location whereAt){
  text = copystring(textString);
  location = whereAt;
}

Message:: Message(Location whereAt){
  text = "";
  location = whereAt;
}

void Message::DisplayIn(Canvas& whichCanvas) {
   canvas = &whichCanvas;
 }

void Message::MoveTo(Location newLocation){
  if (canvas) {
     Clear();
     location = newLocation;
     Draw();
   }
  else location = newLocation;
}

void Message::SetText(char *newText){
  if (canvas) {
     Clear();
     delete text;
     text = copystring(newText);
     Draw();
   }
  else {
     delete text;
     text = copystring(newText);
   }
}

void Message::Draw() {
   if(canvas) 
     canvas->DrawText(text, location);
}

void Message::Clear() {
   if(canvas) {
     Shape msgShape = canvas->TextSize(text);
     canvas->Clear(location, msgShape);
   }
}

char* Message::GetText(){
  return copystring(text);
} 

Message:: ~Message(){
  delete text;
}
