#ifndef _COLOR_H
#define _COLOR_H

/*
CLASS
  Color

  This class represents a color. A color is defined by the combination
  of given amounts of red, green, and blue. This method of defining
  colors is referred to as an RGB color model. Different colors are obtained
  by altering the amounts of the three base colors. The amount of each
  base color is specified as an integer value in the range from 
  0 to 255 (an 8-bit color model). A Color object can be used to specify 
  the colors to be used for drawing and filling  in a Canvas. 
*/

class Color
{
  private:
    int redValue;
	int greenValue;
	int blueValue;

  public:
        //////////
        // Construct a color defined by the combination of the given
        // amounts of the base colors red, green, and blue.
        //<UL>
        //<LI><B>red </B>: the amount of red in the color</LI>
        //<LI><B>green </B>: the amount of green in the color </LI>
        //<LI><B>blue </B>: the amount of of blue in the color</LI>
        //</UL>
	Color(int red, int green, int blue);

        //////////
        // Return the amount of red in the current color.
	int Red();

        //////////
        // Return the amount of green in the current color.
	int Green();

        //////////
        // Return the amount of blue in the current color.
	int Blue();

        //////////
        // Destructor for the Color class.
	~Color();
};

#endif
