#ifndef _TEXTBOX_H
#define _TEXTBOX_H

#include "wx.h"
#include "Location.h"
#include "Shape.h"

/* This class captures the concept of a passage of text that can
   be changed under program control. The text is surrounded by a
   box that has an optional label to identify the meaning of the
   text.
*/
   


class TextBox {
private:
  wxText* systemTextBox;
  Location position;
  Shape shape;
  char* currentLabel;
  char* currentValue; 
  friend class Panel;

public:
        TextBox( Location p, Shape s, char* label); 
        TextBox( Location p, Shape s);
        TextBox( char* label);
        TextBox();
       ~TextBox();
  char* GetText();
  void  SetText(char* val);
};

#endif


