#ifndef _MESSAGE_H
#define _MESSAGE_H

#include "Location.h"
#include "Canvas.h"

class Message {
 private:
   char     *text;               // text being displayed
   Location  location;           // at this location
   Canvas   *canvas;             // in this window

 public:
   Message(char *textString, Location whereAt);
   Message(Location whereAt);
   Message (const Message& other);  // copy constructor
   void DisplayIn(Canvas& whichCanvas);
   void MoveTo(Location newLocation);
   void SetText(char *newText);
   char *GetText();
   void Draw();
   void Clear();
   void operator= (const Message& other); //assignment operator
   ~Message();
};

#endif



