#ifndef _RECTANGLE3_H
#define _RECTANGLE3_H

#include "Location.h"
#include "Shape.h"
#include "Canvas.h"
#include "Color.h"

// This revised version of the Rectangle class contains
// two extensions to the original class:
//  1. the use of private methods
//  2. the use of a static (class) variable

class Rectangle3
{
  private:
	  Location upperLeft;
	  Location upperRight;
	  Location lowerLeft;
	  Location lowerRight;
	  Shape    area;

	  void AdjustCorners();        //private method

	  static Color rectangleColor; // class variable

	   Rectangle3 (Location corner, Shape shape);
	   friend class RectangleFactory;

  public:
	 
	  void MoveUp    (int deltaY);
	  void MoveDown  (int deltaY);
	  void MoveLeft  (int deltaX);
	  void MoveRight (int deltaX);
	  void Draw(Canvas& canvas);
	  void Clear(Canvas& canvas);
	  void SetColor(Color color);
	  ~Rectangle3();
};

#endif
