#ifndef _STOPWATCH_H
#define _STOPWATCH_H

#include "Button.h"
#include "Location.h"
#include "Shape.h"
#include "Clock.h"
#include "Canvas.h"
#include "Panel.h"
#include "Counter.h"
#include "Message.h"


class StopWatch
{
  private:
	  Button  startButton;
	  Button  stopButton; 
	  Clock   clock;
	  Counter clockCount;
	  Message clockDisplay;
	  Panel   buttonPanel;
	  Canvas  canvas;

  public:
	  StopWatch(Frame& frame, Location where, 
		        int interval = 1000);
	  void ButtonPushed(char* buttonName);
	  void Tick();
	  int ElapsedTime();
	  ~StopWatch();

};
#endif
