
#include "Base.h"
#include "Frame.h"
#include "Canvas.h"
#include "Color.h"


/* This program illustrates the use of colors in drawing
   shapes on a Canvas object. A series of lines of increasing
   intensity for each primary color (red, green, blue) is
   drawn. Then a filled circle and a filled triangle are
   drawn. The triangle shows how to draw arbitrary polygons.
  
*/

  
// Declare object here

     Frame window  ("TestWindow", Location(100,100), Shape(500, 300));
     Canvas canvas (window, "DrawAreas",  Location(1, 1),  Shape(100, 100));
     
     
void OnStart()	      // called once when "Start" button pushed
{  canvas.Clear();
   for(int i = 0; i < 10; i++)
   {
      canvas.SetDrawColor(Color(25*i, 25*0, 25*0));
      canvas.DrawLine(Location(10, 10*i + 10), 
		              Location(100,10*i + 10));

	  canvas.SetDrawColor(Color(25*0, 25*i, 25*0));
      canvas.DrawLine(Location(110,10*i + 10), 
		              Location(200,10*i + 10));

	  canvas.SetDrawColor(Color(25*0, 25*0, 25*i));
      canvas.DrawLine(Location(210,10*i + 10), 
		              Location(300,10*i + 10));
   }

   canvas.SetFillColor(Color(100, 25, 25));
   canvas.DrawCircle(Location(250, 200), 50);

   canvas.SetFillColor(Color(25,25,200));
   Location triangle[3];
   triangle[0] = Location(100, 150);
   triangle[1] = Location( 25, 250);
   triangle[2] = Location(175, 250);
   canvas.DrawLine(triangle[0], triangle[1]);
   canvas.DrawLine(triangle[1], triangle[2]);
   canvas.DrawLine(triangle[2], triangle[0]);
}


void OnPush(char *buttonLabel) 
{  
}

void OnPaint()
{ for(int i = 0; i < 10; i++)
   {
      canvas.SetDrawColor(Color(25*i, 25*0, 25*0));
      canvas.DrawLine(Location(10, 10*i + 10), 
		              Location(100,10*i + 10));

      canvas.SetDrawColor(Color(25*0, 25*i,25*0));
      canvas.DrawLine(Location(110,10*i + 10), 
		              Location(200,10*i + 10));

	  canvas.SetDrawColor(Color(25*0, 25*0, 25*i));
      canvas.DrawLine(Location(210,10*i + 10), 
		              Location(300,10*i + 10));
      canvas.SetFillColor(Color(100, 25, 25));
      canvas.DrawCircle(Location(250, 200), 50);
    
      canvas.SetFillColor(Color(25,25,200));
      Location triangle[3];
      triangle[0] = Location(100, 150);
      triangle[1] = Location( 25, 250);
      triangle[2] = Location(175, 250);
      canvas.DrawLine(triangle[0], triangle[1]);
	  canvas.DrawLine(triangle[1], triangle[2]);
      canvas.DrawLine(triangle[2], triangle[0]);
    }   
} 


void OnTimerEvent(char* clockName) 
{
}

void OnMouseEvent(char *canvasName, int x, int y, int keys)
{
}








