#include "Program.h"
#include "Frame.h"
#include "Canvas.h"
#include "Message.h"
#include "Location.h"
#include "Shape.h"
#include "Clock.h"
#include "Button.h"
#include "Panel.h"

Frame   window   ("Message Test", Location(100,100), Shape(200,300));
Canvas  canvas   (window, "Message Area", Location(10,10), Shape(180,180));
Panel   panel    (window, "Button Area", Location(10,200), Shape(180,90));
Message tick     ("Tick", Location(20,20));
Message tock     ("Tock", Location(20,20));
Clock   timer    ("timer", 500);
Button  stop     ("Stop", Location(80, 20), Shape(50, 20));
int     TickOrTock; // 1 = tick, 0 = tock

void OnStart() {
   tick.DisplayIn(canvas);
   tock.DisplayIn(canvas);
   tick.Draw();
   tock.Clear();
   panel.Add(stop);
   TickOrTock = 1;
   timer.Start();
};

void OnMouseEvent(char *canvasName, int x, int y, int buttonState){
  if (buttonState & leftButtonDown) {
	  tick.MoveTo(Location(x,y));
	  tock.MoveTo(Location(x,y));
  }

}

void OnTimerEvent(char* clockName) 
{
   if( timer.IsNamed(clockName) )
   {   if (TickOrTock == 1) { tick.Clear(); tock.Draw(); TickOrTock = 0; }
       else                 { tock.Clear(); tick.Draw(); TickOrTock = 1; }
   }
}

void OnPaint() {
   canvas.Clear();
   if (TickOrTock == 1) tick.Draw();
   else                 tock.Draw();
}          

void OnPush(char* buttonName) {
  if(stop.IsNamed(buttonName)) {
     timer.Stop();
  }
}
