#include "Rectangle3.h"
#include "RectangleFactory.h"
#include "Canvas.h"
#include "Frame.h"

Frame window("Rectangle Test", Location(100,100), 
			                   Shape(300,300));
Canvas canvas(window, "Rectangle Area", Location(10,10),
			                             Shape(200,200));
Rectangle3 *rect1, *rect2, *rect3, *rect4
;
RectangleFactory squareFactory(Shape(50,50));
RectangleFactory thinFactory(Shape(100,10));

void OnStart()
{
	rect1 = squareFactory.New(Location(10,10));
	rect2 = squareFactory.New(Location(70,10));
	rect3 = thinFactory.New(Location(20,100));
	rect4 = thinFactory.New(Location(20,150));

	rect1->Draw(canvas);
	rect2->Draw(canvas);
	rect3->Draw(canvas);
	rect4->Draw(canvas);
}

void OnPaint()
{ rect1->Draw(canvas);
  rect2->Draw(canvas);
  rect3->Draw(canvas);
  rect4->Draw(canvas);
}

void OnTimerEvent(char* timerName)
{
}

void OnMouseEvent(char* canvasName, int x, int y, int buttonState)
{
}

void OnPush(char* buttonName)
{
}
