// Steve Leighty
// 287-72-4242
// cs 2704
// Project 1 : Ecology Environment
// This program creates an ecology environment

#include "Base.h"
#include "Frame.h"
#include "Canvas.h"
#include "Button.h"
#include "Panel.h"
#include "TextBox.h"
#include "Program.h"
#include "Clock.h"
#include "Counter.h"
#include "Location.h"
#include "Shape.h"
#include "Message.h"


     Frame window  ("Ecology Environment", Location(50,50), Shape(700, 700));
     Canvas ecoCanvas (window, "Wildlife Area",  Location(1, 1),  
		                                  Shape(400, 300));
	 Canvas infoCanvas (window, "Wildlife Area",  Location(401, 1),  
		                                  Shape(300, 300));
     Panel  panel  (window, "Controls", Location(25, 350), 
		                                Shape(550, 200));
     Button startbutton ("Start", Location(5, 5), Shape(100,30)); 
	 Button quitbutton ("Quit", Location(5, 40), Shape(100,30)); 
	 Button pausebutton ("Pause", Location(5, 75), Shape(100,30)); 
     Button  predcopy   ("Enter",  Location(351, 5),  Shape(50,30));
     Button  preycopy   ("Enter1",  Location(351, 50),  Shape(50,30));
	 Button  speedcopy  ("Enter2", Location(351, 100), Shape(50,30));

     TextBox predbox(Location(200,5), Shape(150,30), "Predator Rate:");
	 TextBox preybox(Location(200,50), Shape(150,30), "Prey Rate:");
	 TextBox speedbox(Location(200,100), Shape(150,30), "Sim Speed:");

     Message predrate("", Location(40,30));
	 Message preyrate("", Location(40,70));
	 Message predator("Predator Rate", Location(20, 10));
	 Message prey("Prey Rate", Location(20, 50));
	 Message numpred("Number of Predators", Location(20, 90));
	 Message numprey("Number of Prey", Location(20, 130));
	 Message showTime("Current Time Step", Location(20, 170));
	 Message timeDisplay("0", Location(40,190));
	 Message showSpeed("Speed of Simulation", Location(20,210));
	 Message speedDisplay("", Location(40,230));
	 
	 Clock timer("Timer", 100);	// 100 millisecond interval 
	 Counter elapsedTime;	// increments on each 'tick' of timer

	 int startTimer;


     
void OnStart()	      // called once when "Start" button pushed
{     
   ecoCanvas.Clear();
   infoCanvas.Clear();

   panel.Add(startbutton);
   panel.Add(quitbutton);
   panel.Add(pausebutton);
   panel.Add(predbox);
   panel.Add(preybox);
   panel.Add(predcopy);
   panel.Add(preycopy);
   panel.Add(speedbox);
   panel.Add(speedcopy);

   predrate.DisplayIn(infoCanvas);
   preyrate.DisplayIn(infoCanvas);
   predator.DisplayIn(infoCanvas);
   prey.DisplayIn(infoCanvas);
   numpred.DisplayIn(infoCanvas);
   numprey.DisplayIn(infoCanvas);
   timeDisplay.DisplayIn(infoCanvas);
   showTime.DisplayIn(infoCanvas);
   showSpeed.DisplayIn(infoCanvas);
   speedDisplay.DisplayIn(infoCanvas);

   elapsedTime.ConnectTo(timeDisplay);
   timer.Start();


}


void OnPush(char *buttonLabel) 
{  if (predcopy.IsNamed(buttonLabel)) 
   {   predrate.SetText(predbox.GetText()); 
   }

   if (preycopy.IsNamed(buttonLabel)) 
   {   preyrate.SetText(preybox.GetText()); 
   }

   if (speedcopy.IsNamed(buttonLabel)) 
   {   speedDisplay.SetText(speedbox.GetText()); 
   }

   if (startbutton.IsNamed(buttonLabel)) 
   {   startTimer = 1;
   }

   if (pausebutton.IsNamed(buttonLabel))
   {   startTimer = !(startTimer);
   }

   if (quitbutton.IsNamed(buttonLabel))
   {   
   }

}


void OnPaint()
{  

	predrate.Draw();
	preyrate.Draw();
	predator.Draw();
	prey.Draw();
	showTime.Draw();
	timeDisplay.Draw();
	showSpeed.Draw();
	speedDisplay.Draw();
	numpred.Draw();
	numprey.Draw();
}

void OnTimerEvent(char* clockName) 
{
	if (timer.IsNamed("Timer") ) 
	{
	  if (startTimer == 0) 
		{
		  OnPaint();
		}
	  if (startTimer == 1)
		{
	  	  elapsedTime.Next();
		  OnPaint();
		}
	}
}

void OnMouseEvent(char *canvasName, int x, int y, int keys)
{ //if(keys & leftButtonDown) OnPaint(); 
}

