#include "Panel.h"

Panel::Panel(Frame& fr, char *nm, Location loc, Shape sh) {
  name = copystring(nm);
  location = loc; 
  shape = sh;
  frame = &fr; wxp = (wxPanel*)0;
}

char* Panel::getName() { return copystring(name); }

void Panel::Add(Button& button) {
  CreateIfNeeded();
  button.CreateIfNeeded(wxp);
}

void Panel::Add(TextBox& tbox)
{  CreateIfNeeded();
   (tbox.systemTextBox)  = new wxText(wxp, NULL,
                          tbox.currentLabel,  "",
                          tbox.position.Xcoord(), tbox.position.Ycoord(),
                          tbox.shape.Width(), tbox.shape.Height() );
    if (tbox.currentValue) tbox.systemTextBox->SetValue(tbox.currentValue);
}

Panel::~Panel() {}

void Panel::CreateIfNeeded() {
  frame->CreateIfNeeded();
  if (!wxp) wxp = new wxPanel(frame->frame, 
                              location.Xcoord(), location.Ycoord(),
                              shape.Width(), shape.Height(),
                              0, name);
}
