#include "PolyShape.h"

PolyShape::PolyShape (int x, int y)
{ Location *start = new Location(x,y);
  head = tail = new LocationNode(start);
  currentX = x; currentY = y;
  length = 1;
}


  void PolyShape::Up(int n)
  { currentY = currentY - n;
  }

  void PolyShape::Down(int n)
  { currentY = currentY + n;
  }

  void PolyShape::Left(int n)
  { currentX = currentX - n;
  }

  void PolyShape::Right(int n)
  { currentX = currentX + n;
  }



void PolyShape::Mark()
{ Location *newPoint   = new Location(currentX, currentY);
  LocationNode *newNode = new LocationNode(newPoint);
  tail->Next(newNode);
  tail = newNode;
  length = length + 1;
}

void PolyShape::Draw(Canvas& canvas)
{ if (length == 1) return;
  LocationNode *node, *next;
  node = head;
  for(int i=0; i<length-1; i++)
  { next = node->Next();
    canvas.DrawLine(node->Contents(), 
	                next->Contents());
    node = next;
  }
  canvas.DrawLine(head->Contents(), 
	              node->Contents());
}

PolyShape::~PolyShape()
{ LocationNode *next = head;
  while (next)
  { LocationNode *node = next->Next();
    delete next;
	next = node;
  }
}
