#include "Rectangle2.h"

Color Rectangle2::rectangleColor = Color(200,0,0); // a shade of red

void Rectangle2::AdjustCorners()
{ upperRight = Location(upperLeft.Xcoord() + area.Width(),
						upperLeft.Ycoord());
  lowerLeft  = Location(upperLeft.Xcoord() ,
	                    upperLeft.Ycoord() + area.Height());
  lowerRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord() + area.Height());
}

Rectangle2::Rectangle2(Location corner, Shape shape)
{ upperLeft  = corner;
  area = shape;
  AdjustCorners();
}

void Rectangle2::MoveUp(int deltaY)
{ upperLeft  = Location(upperLeft.Xcoord(),
						upperLeft.Ycoord() + deltaY);
  AdjustCorners();
}

void Rectangle2::MoveDown(int deltaY)
{ upperLeft  = Location(upperLeft.Xcoord(),
						upperLeft.Ycoord() + deltaY);
  AdjustCorners();
}

void Rectangle2::MoveLeft(int deltaX)
{ upperLeft  = Location(upperLeft.Xcoord() + deltaX,
						upperLeft.Ycoord());
  AdjustCorners();
}

void Rectangle2::MoveRight(int deltaX)
{ upperLeft  = Location(upperLeft.Xcoord() + deltaX,
						upperLeft.Ycoord());
  AdjustCorners();
}

void Rectangle2::Draw(Canvas& canvas)
{ canvas.SetDrawColor(rectangleColor);
  canvas.DrawLine(upperLeft,  upperRight);
  canvas.DrawLine(upperRight, lowerRight);
  canvas.DrawLine(lowerRight, lowerLeft);
  canvas.DrawLine(lowerLeft,  upperLeft);
}

void Rectangle2::SetColor(Color color)
{ rectangleColor = color; // change for all Rectangle objects
}

void Rectangle2::Clear(Canvas& canvas)
{ canvas.Clear(upperLeft, area);
}

Rectangle2::~Rectangle2() {}
