#include "Rectangle3.h"

Color Rectangle3::rectangleColor = Color(200,0,0); // a shade of red

void Rectangle3::AdjustCorners()
{ upperRight = Location(upperLeft.Xcoord() + area.Width(),
						upperLeft.Ycoord());
  lowerLeft  = Location(upperLeft.Xcoord() ,
	                    upperLeft.Ycoord() + area.Height());
  lowerRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord() + area.Height());
}

Rectangle3::Rectangle3(Location corner, Shape shape)
{ upperLeft  = corner;
  area = shape;
  AdjustCorners();
}

void Rectangle3::MoveUp(int deltaY)
{ upperLeft  = Location(upperLeft.Xcoord(),
						upperLeft.Ycoord() + deltaY);
  AdjustCorners();
}

void Rectangle3::MoveDown(int deltaY)
{ upperLeft  = Location(upperLeft.Xcoord(),
						upperLeft.Ycoord() + deltaY);
  AdjustCorners();
}

void Rectangle3::MoveLeft(int deltaX)
{ upperLeft  = Location(upperLeft.Xcoord() + deltaX,
						upperLeft.Ycoord());
  AdjustCorners();
}

void Rectangle3::MoveRight(int deltaX)
{ upperLeft  = Location(upperLeft.Xcoord() + deltaX,
						upperLeft.Ycoord());
  AdjustCorners();
}

void Rectangle3::Draw(Canvas& canvas)
{ canvas.SetDrawColor(rectangleColor);
  canvas.DrawLine(upperLeft,  upperRight);
  canvas.DrawLine(upperRight, lowerRight);
  canvas.DrawLine(lowerRight, lowerLeft);
  canvas.DrawLine(lowerLeft,  upperLeft);
}

void Rectangle3::SetColor(Color color)
{ rectangleColor = color; // change for all Rectangle objects
}

void Rectangle3::Clear(Canvas& canvas)
{ canvas.Clear(upperLeft, area);
}

Rectangle3::~Rectangle3() {}
